import "Turbine.Utils";
import "Turbine.Gameplay";
import "PengorosPlugins.BuffBars";

CoolDownManager = class();

function CoolDownManager:Constructor()
    -- listeners
    self.listeners = {};
    
    -- create the pots
    self.activePots = {};
    self.pots = 
    {
        Pot("Morale", Settings.MoraleCoolDown, 120, {"Concentrated Essence of Athelas", "Distilled Athelas Essence", "Distilled Athelas Extract", "Elixir of Twice Purified Athelas", "Enhanced Essence of Athelas", "Greater Athelas Essence", "Greater Athelas Extract", "Infused Athelas Essence", "Infused Athelas Extract", "Lesser Athelas Essence", "Lesser Athelas Extract", "Potent Athelas Essence", "Pure Athelas Essence", "Pure Athelas Extract", "Refined Athelas Essence", "Refined Athelas Extract", "Simple Athelas Essence", "Simple Athelas Extract", "Steeped Athelas Essence"}),
        Pot("Morale (Store)", Settings.MoraleCoolDown, 20, {"Lesser Draught of Morale", "Minor Draught of Morale", "Moderate Draught of Morale", "Draught of Morale", "Greater Draught of Morale", "Major Draught of Morale", "Superior Draught of Morale"}),
        Pot("Power", Settings.PowerCoolDown, 120, {"Distilled Celebrant Ointment", "Distilled Celebrant Salve", "Elixir of Twice Purified Celebrant", "Greater Celebrant Ointment", "Greater Celebrant Salve", "Infused Celebrant Ointment", "Infused Celebrant Salve", "Lesser Celebrant Ointment", "Lesser Celebrant Salve", "Potent Celebrant Salve", "Pure Celebrant Ointment", "Pure Celebrant Salve", "Refined Celebrant Ointment", "Refined Celebrant Salve", "Simple Celebrant Ointment", "Simple Celebrant Salve", "Steeped Celebrant Salve"}),
        Pot("Power (Store)", Settings.PowerCoolDown, 20, {"Lesser Draught of Power", "Minor Draught of Power", "Moderate Draught of Power", "Draught of Power", "Greater Draught of Power", "Major Draught of Power", "Superior Draught of Power"}),
        Pot("Disease", Settings.DiseaseCoolDown, 30, {"Brewed Flask of Lhinestad", "Brewed Salve of Lhinestad", "Distilled Lhinestad Draught", "Distilled Lhinestad Salve", "Flask of Lhinestad", "Greater Lhinestad Draught", "Greater Lhinestad Salve", "Infused Lhinestad Draught", "Infused Lhinestad Salve", "Lesser Lhinestad Draught", "Lesser Lhinestad Salve", "Pure Flask of Lhinestad", "Pure Salve of Lhinestad", "Refined Lhinestad Draught", "Refined Lhinestad Salve", "Salve of Lhinestad", "Simple Lhinestad Draught", "Simple Lhinestad Salve", "Steeped Lhinestad Draught"}),
        Pot("Disease (Store)", Settings.DiseaseCoolDown, 30, {"Lesser Disease Remedy", "Minor Disease Remedy", "Moderate Disease Remedy", "Disease Remedy", "Greater Disease Remedy", "Major Disease Remedy", "Superior Disease Remedy"}),
        Pot("Fear", Settings.FearCoolDown, 30, {"Brewed Flask of Conhuith", "Brewed Salve of Conhuith", "Distilled Conhuith Draught", "Distilled Conhuith Salve", "Flask of Conhuith", "Greater Conhuith Draught", "Greater Conhuith Salve", "Infused Conhuith Draught", "Infused Conhuith Salve", "Lesser Conhuith Draught", "Lesser Conhuith Salve", "Pure Flask of Conhuith", "Pure Salve of Conhuith", "Refined Conhuith Draught", "Refined Conhuith Salve", "Salve of Conhuith", "Simple Conhuith Draught", "Simple Conhuith Salve", "Steeped Conhuith Draught"}),
        Pot("Fear (Store)", Settings.FearCoolDown, 30, {"Lesser Fear Remedy", "Minor Fear Remedy", "Moderate Fear Remedy", "Fear Remedy", "Greater Fear Remedy", "Major Fear Remedy", "Superior Fear Remedy"}),
        Pot("Poison", Settings.PoisonCoolDown, 30, {"Brewed Milkthistle Draught", "Brewed Milkthistle Salve", "Distilled Milkthistle Draught", "Distilled Milkthistle Salve", "Greater Milkthistle Draught", "Greater Milkthistle Salve", "Infused Milkthistle Draught", "Infused Milkthistle Salve", "Lesser Milkthistle Draught", "Lesser Milkthistle Salve", "Milkthistle Draught", "Milkthistle Salve", "Pure Milkthistle Draught", "Pure Milkthistle Salve", "Refined Milkthistle Draught", "Refined Milkthistle Salve", "Simple Milkthistle Draught", "Simple Milkthistle Salve", "Steeped Milkthistle Draught"}),
        Pot("Poison (Store)", Settings.PoisonCoolDown, 30, {"Lesser Poison Remedy", "Minor Poison Remedy", "Moderate Poison Remedy", "Poison Remedy", "Greater Poison Remedy", "Major Poison Remedy", "Superior Poison Remedy"}),
        Pot("Wound", Settings.WoundCoolDown, 30, {"Brewed Healing Draught", "Brewed Healing Salve", "Distilled Healing Draught", "Distilled Healing Salve", "Greater Healing Draught", "Greater Healing Salve", "Healing Draught", "Healing Salve", "Infused Healing Draught", "Infused Healing Salve", "Lesser Healing Draught", "Lesser Healing Salve", "Pure Healing Draught", "Pure Healing Salve", "Refined Healing Draught", "Refined Healing Salve", "Simple Healing Draught", "Simple Healing Salve", "Steeped Healing Draught"}),
        Pot("Wound (Store)", Settings.WoundCoolDown, 30, {"Lesser Wound Remedy", "Minor Wound Remedy", "Moderate Wound Remedy", "Wound Remedy", "Greater Wound Remedy", "Major Wound Remedy", "Superior Wound Remedy"}),
    };
    
    -- list of the backpack items
    self.items = {};
    
    -- hack control to get update events, remove when we can get updates without being a control
    self.update = Turbine.UI.Control();
    self.update:SetVisible(false);
    self.update:SetWantsUpdates(false);
    self.update.Update = function(sender, args)
        self:ProcessUpdate();
    end
    
    -- process the backpack
    self.backpack = Turbine.Gameplay.LocalPlayer():GetBackpack();
    local i;
    for i = 1, self.backpack:GetSize() do
        self:AddItem(i);
    end

    self.backpack.ItemAdded = function(sender, args)
        self:AddItem(args.Index);
    end

    self.backpack.ItemRemoved = function(sender, args)
        self:RemoveItem(args.Index);
    end
    
    self.backpack.ItemMoved = function(sender, args)
        self:SwapItems(args.OldIndex, args.NewIndex);
    end
end

function CoolDownManager:AddItem(index)
    local item = self.backpack:GetItem(index);
    self.items[index] = item;
    if (item == nil) then
        return;
    end
    
    local name = item:GetName();
    local i;
    for i = 1, table.getn(self.pots) do
        local pot = self.pots[i];
        if (pot:IsMatch(name)) then
            local quantity = item:GetQuantity();
            item.QuantityChanged = function(sender, args)
                local newQuantity = sender:GetQuantity();
                if ((quantity - 1) == newQuantity) then
                    pot:Start();
                    self:AddPot(pot);
                end
                quantity = newQuantity;
            end
            break;
        end
    end
end

function CoolDownManager:RemoveItem(index)
    local item = self.items[index];
    self.items[index] = nil;
    if (item ~= nil and item.QuantityChanged ~= nil) then
        item.QuantityChanged = nil;
    end
end

function CoolDownManager:SwapItems(oldIndex, newIndex)
    local old = self.backpack:GetItem(oldIndex);
    local new = self.backpack:GetItem(newIndex);
    self.items[oldIndex] = old;
    self.items[newIndex] = new;
end

function CoolDownManager:ProcessUpdate()
    local gameTime = Turbine.Engine.GetGameTime();
    local remove = {};
    local i;
    for i = 1, table.getn(self.activePots) do
        local elapsedTime = gameTime - self.activePots[i].startTime;
        if (elapsedTime > self.activePots[i].duration) then
            table.insert(remove, self.activePots[i]);
        end
    end
    
    for i = 1, table.getn(remove) do
        self:RemovePot(remove[i]);
    end
end

function CoolDownManager:AddListener(listener)
    -- make sure it isn't in the list already
    self:RemoveListener(listener);
    table.insert(self.listeners, listener);
end

function CoolDownManager:RemoveListener(listener)
    local i;
    for i = 1, table.getn(self.listeners) do
        if (self.listeners[i] == listener) then
            table.remove(self.listeners, i);
            break;
        end
    end
end

function CoolDownManager:GetPots()
    return self.activePots;
end

function CoolDownManager:AddPot(pot)
    table.insert(self.activePots, pot);
    local i;
    for i = 1, table.getn(self.listeners) do
        if (type(self.listeners[i].PotAdded) == "function") then
            self.listeners[i]:PotAdded(pot);
        end
    end
    self.update:SetWantsUpdates(true);
end

function CoolDownManager:RemovePot(pot)
    for i = 1, table.getn(self.activePots) do
        if (self.activePots[i] == pot) then
            table.remove(self.activePots, i);
            break;
        end
    end

    for i = 1, table.getn(self.listeners) do
        if (type(self.listeners[i].PotRemoved) == "function") then
            self.listeners[i]:PotRemoved(pot);
        end
    end
    self.update:SetWantsUpdates(table.getn(self.activePots) > 0);
end
