import "Turbine.Utils";
import "Turbine.Gameplay";
import "PengorosPlugins.BuffBars";

LogSettings = class();

function LogSettings:Constructor(saved)
    if (saved ~= nil) then
        for i,v in pairs(saved) do
            self[i] = v;
        end
    else
        self:SetDefaults();
    end
end

function LogSettings:Copy()
    -- deep copy table function
    local function deepcopy(object)
        local lookup_table = {}
        local function _copy(object)
            if type(object) ~= "table" then
                return object
            elseif lookup_table[object] then
                return lookup_table[object]
            end
            local new_table = {}
            lookup_table[object] = new_table
            for index, value in pairs(object) do
                new_table[_copy(index)] = _copy(value)
            end
            return setmetatable(new_table, getmetatable(object))
        end
        return _copy(object)
    end
    
    return deepcopy(self);
end

function LogSettings:SetDefaults()
    self.enabled = false;
    
    -- items to log
    self.logId = true;
    self.logName = true;
    self.logDescription = true;
    self.logCategory = true;
    self.logDuration = true;
    self.logCurable = true;
    self.logDebuff = true;
    
    -- minimal filters
    self.showBuffs = true;
    self.showDebuffs = true;
end
