import "Turbine.UI";

OptionsEffectPanel = class(Turbine.UI.Control);

OptionsEffectPanel.FlashElapsed = 1;
OptionsEffectPanel.FlashRemaining = 2;
OptionsEffectPanel.DiseaseElapsed = 3;
OptionsEffectPanel.DiseaseRemaining = 4;
OptionsEffectPanel.FearElapsed = 5;
OptionsEffectPanel.FearRemaining = 6;
OptionsEffectPanel.PoisonElapsed = 7;
OptionsEffectPanel.PoisonRemaining = 8;
OptionsEffectPanel.WoundElapsed = 9;
OptionsEffectPanel.WoundRemaining = 10;
OptionsEffectPanel.CorruptionElapsed = 11;
OptionsEffectPanel.CorruptionRemaining = 12;
OptionsEffectPanel.CryElapsed = 13;
OptionsEffectPanel.CryRemaining = 14;
OptionsEffectPanel.ElementalElapsed = 15;
OptionsEffectPanel.ElementalRemaining = 16;
OptionsEffectPanel.PhysicalElapsed = 17;
OptionsEffectPanel.PhysicalRemaining = 18;
OptionsEffectPanel.SongElapsed = 19;
OptionsEffectPanel.SongRemaining = 20;
OptionsEffectPanel.UndefinedElapsed = 21;
OptionsEffectPanel.UndefinedRemaining = 22;
OptionsEffectPanel.MoraleCoolDownElapsed = 23;
OptionsEffectPanel.MoraleCoolDownRemaining = 24;
OptionsEffectPanel.PowerCoolDownElapsed = 25;
OptionsEffectPanel.PowerCoolDownRemaining = 26;
OptionsEffectPanel.DiseaseCoolDownElapsed = 27;
OptionsEffectPanel.DiseaseCoolDownRemaining = 28;
OptionsEffectPanel.FearCoolDownElapsed = 29;
OptionsEffectPanel.FearCoolDownRemaining = 30;
OptionsEffectPanel.PoisonCoolDownElapsed = 31;
OptionsEffectPanel.PoisonCoolDownRemaining = 32;
OptionsEffectPanel.WoundCoolDownElapsed = 33;
OptionsEffectPanel.WoundCoolDownRemaining = 34;

function OptionsEffectPanel:Constructor()
    Turbine.UI.Control.Constructor(self);

    self.current = nil;
    self.ignoreWasVisible = false;
    self.overrideWasVisible = false;
    
    -- listen for events
    keyManager:AddListener(self);

    local y = 0;
    self.windowTitle = PengorosPlugins.UI.PanelDivider();
    self.windowTitle:SetParent(self);
    self.windowTitle:SetText("Effect Windows");
    self.windowTitle:SetSize(300, 30);
    self.windowTitle:SetPosition(20, y);
    y = y + 35;
    
    self.windowLabel = PengorosPlugins.UI.Label();
    self.windowLabel:SetParent(self);
    self.windowLabel:SetSize(176, 20);
    self.windowLabel:SetPosition(0, y);
    self.windowLabel:SetText("Window");
    
    self.windowCombo = PengorosPlugins.UI.ComboBox();
    self.windowCombo:SetParent(self);
    self.windowCombo:SetSize(204, 20);
    self.windowCombo:SetPosition(176, y);
    self.windowCombo.SelectedIndexChanged = function(sender, args)
        if (self.current ~= nil) then
            self:SaveWindowOptions(self.current);
        end
        self:SetWindowOptions(args.selection);
        self.current = args.selection;
    end
    y = y + 30;
    
    self.newButton  = Turbine.UI.Lotro.Button();
    self.newButton:SetParent(self);
    self.newButton:SetPosition(69, y);
    self.newButton:SetSize(100, 22);
    self.newButton:SetText("New");
    self.newButton.Click = function(sender, args)
        self:AddNewWindow();
    end

    self.copyButton  = Turbine.UI.Lotro.Button();
    self.copyButton:SetParent(self);
    self.copyButton:SetPosition(176, y);
    self.copyButton:SetSize(100, 22);
    self.copyButton:SetText("Copy");
    self.copyButton.Click = function(sender, args)
        self:CopyCurrentWindow();
    end

    self.removeButton  = Turbine.UI.Lotro.Button();
    self.removeButton:SetParent(self);
    self.removeButton:SetPosition(283, y);
    self.removeButton:SetSize(100, 22);
    self.removeButton:SetText("Remove");
    self.removeButton.Click = function(sender, args)
        self:RemoveCurrentWindow();
    end
    y = y + 30;

    self.generalTitle = PengorosPlugins.UI.PanelDivider();
    self.generalTitle:SetParent(self);
    self.generalTitle:SetText("General");
    self.generalTitle:SetSize(300, 30);
    self.generalTitle:SetPosition(20, y);
    y = y + 35;
    
    self.nameLabel = PengorosPlugins.UI.Label();
    self.nameLabel:SetParent(self);
    self.nameLabel:SetSize(100, 20);
    self.nameLabel:SetPosition(0, y);
    self.nameLabel:SetText("Name");
    
    self.nameText = Turbine.UI.Lotro.TextBox();
    self.nameText:SetParent(self);
    self.nameText:SetSize(280, 20);
    self.nameText:SetPosition(100, y);
    self.nameText:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    self.nameText:SetMultiline(false);
    self.nameText:SetWantsUpdates(true);
    self.nameText.Update = function(sender, args)
        self.windowCombo:UpdateSelectionText(self.nameText:GetText());
    end
    y = y + 30;
    
    self.showWindowCB = PengorosPlugins.UI.CheckBox();
    self.showWindowCB:SetParent(self);
    self.showWindowCB:SetText("Enabled");
    self.showWindowCB:SetPosition(0, y);
    self.showWindowCB:SetSize(380, 20);
    y = y + 20;

    self.showDebuffBarCB = PengorosPlugins.UI.CheckBox();
    self.showDebuffBarCB:SetParent(self);
    self.showDebuffBarCB:SetText("Show Debuff Bar");
    self.showDebuffBarCB:SetPosition(0, y);
    self.showDebuffBarCB:SetSize(380, 20);
    y = y + 20;
    
    self.showBuffBarCB = PengorosPlugins.UI.CheckBox();
    self.showBuffBarCB:SetParent(self);
    self.showBuffBarCB:SetText("Show Buff Bar");
    self.showBuffBarCB:SetPosition(0, y);
    self.showBuffBarCB:SetSize(380, 20);
    y = y + 20;

    self.showCoolDownBarCB = PengorosPlugins.UI.CheckBox();
    self.showCoolDownBarCB:SetParent(self);
    self.showCoolDownBarCB:SetText("Show Cool Down Bar");
    self.showCoolDownBarCB:SetPosition(0, y);
    self.showCoolDownBarCB:SetSize(380, 20);
    y = y + 25;

    self.visibleTypeLabel = PengorosPlugins.UI.Label();
    self.visibleTypeLabel:SetParent(self);
    self.visibleTypeLabel:SetSize(190, 20);
    self.visibleTypeLabel:SetPosition(0, y);
    self.visibleTypeLabel:SetText("Show Window");
    
    self.visibleTypeCombo = PengorosPlugins.UI.ComboBox();
    self.visibleTypeCombo:SetParent(self);
    self.visibleTypeCombo:SetSize(190, 20);
    self.visibleTypeCombo:SetPosition(190, y);
    self.visibleTypeCombo:AddItem("Always", EffectWindow.VisibleAlways);
    self.visibleTypeCombo:AddItem("Only In Combat", EffectWindow.VisibleInCombat);
    self.visibleTypeCombo:AddItem("Only Out Of Combat", EffectWindow.VisibleOutOfCombat);
    y = y + 30;

    self.sortingTitle = PengorosPlugins.UI.PanelDivider();
    self.sortingTitle:SetParent(self);
    self.sortingTitle:SetText("Sorting");
    self.sortingTitle:SetSize(300, 30);
    self.sortingTitle:SetPosition(20, y);
    y = y + 35;
    
    self.sortLabel = PengorosPlugins.UI.Label();
    self.sortLabel:SetParent(self);
    self.sortLabel:SetSize(190, 20);
    self.sortLabel:SetPosition(0, y);
    self.sortLabel:SetText("Method");
    
    self.sortCombo = PengorosPlugins.UI.ComboBox();
    self.sortCombo:SetParent(self);
    self.sortCombo:SetSize(190, 20);
    self.sortCombo:SetPosition(190, y);
    self.sortCombo:AddItem("Name", EffectWindow.SortName);
    self.sortCombo:AddItem("Time Remaining", EffectWindow.SortTime);
    self.sortCombo:AddItem("Effect Category", EffectWindow.SortCategory);
    self.sortCombo:AddItem("None", EffectWindow.SortNone);
    y = y + 30;
    
    self.directionLabel = PengorosPlugins.UI.Label();
    self.directionLabel:SetParent(self);
    self.directionLabel:SetSize(190, 20);
    self.directionLabel:SetPosition(0, y);
    self.directionLabel:SetText("Direction");
    
    self.directionCombo = PengorosPlugins.UI.ComboBox();
    self.directionCombo:SetParent(self);
    self.directionCombo:SetSize(190, 20);
    self.directionCombo:SetPosition(190, y);
    self.directionCombo:AddItem("Ascending", true);
    self.directionCombo:AddItem("Descending", false);
    y = y + 30;
    
    self.orderLabel = PengorosPlugins.UI.Label();
    self.orderLabel:SetParent(self);
    self.orderLabel:SetSize(190, 20);
    self.orderLabel:SetPosition(0, y);
    self.orderLabel:SetText("Bar Order");
    
    self.orderCombo = PengorosPlugins.UI.ComboBox();
    self.orderCombo:SetParent(self);
    self.orderCombo:SetSize(190, 20);
    self.orderCombo:SetPosition(190, y);
    self.orderCombo:AddItem("Debuffs, Buffs, CD", EffectWindow.OrderDebuffBuffCoolDown);
    self.orderCombo:AddItem("Debuffs, CD, Buffs", EffectWindow.OrderDebuffCoolDownBuff);
    self.orderCombo:AddItem("CD, Debuffs, Buffs", EffectWindow.OrderCoolDownDebuffBuff);
    self.orderCombo:AddItem("CD, Buffs, Debuffs", EffectWindow.OrderCoolDownBuffDebuff);
    self.orderCombo:AddItem("Buffs, CD, Debuffs", EffectWindow.OrderBuffCoolDownDebuff);
    self.orderCombo:AddItem("Buffs, Debuffs, CD", EffectWindow.OrderBuffDebuffCoolDown);
    y = y + 30;

    self.fillLabel = PengorosPlugins.UI.Label();
    self.fillLabel:SetParent(self);
    self.fillLabel:SetSize(190, 20);
    self.fillLabel:SetPosition(0, y);
    self.fillLabel:SetText("Fill");
    
    self.fillCombo = PengorosPlugins.UI.ComboBox();
    self.fillCombo:SetParent(self);
    self.fillCombo:SetSize(190, 20);
    self.fillCombo:SetPosition(190, y);
    self.fillCombo:AddItem("Top to Bottom", false);
    self.fillCombo:AddItem("Bottom to Top", true);
    y = y + 30;

    self.filterTitle = PengorosPlugins.UI.PanelDivider();
    self.filterTitle:SetParent(self);
    self.filterTitle:SetText("Effect Filters");
    self.filterTitle:SetSize(300, 30);
    self.filterTitle:SetPosition(20, y);
    y = y + 35;
    
    self.showCurableOnlyCB = PengorosPlugins.UI.CheckBox();
    self.showCurableOnlyCB:SetParent(self);
    self.showCurableOnlyCB:SetText("Show Curable Only Effects");
    self.showCurableOnlyCB:SetPosition(0, y);
    self.showCurableOnlyCB:SetSize(380, 20);
    y = y + 20;

    self.showDiseaseCB = PengorosPlugins.UI.CheckBox();
    self.showDiseaseCB:SetParent(self);
    self.showDiseaseCB:SetText("Show Disease Effects");
    self.showDiseaseCB:SetPosition(0, y);
    self.showDiseaseCB:SetSize(380, 20);
    y = y + 20;

    self.showFearCB = PengorosPlugins.UI.CheckBox();
    self.showFearCB:SetParent(self);
    self.showFearCB:SetText("Show Fear Effects");
    self.showFearCB:SetPosition(0, y);
    self.showFearCB:SetSize(380, 20);
    y = y + 20;

    self.showPoisonCB = PengorosPlugins.UI.CheckBox();
    self.showPoisonCB:SetParent(self);
    self.showPoisonCB:SetText("Show Poison Effects");
    self.showPoisonCB:SetPosition(0, y);
    self.showPoisonCB:SetSize(380, 20);
    y = y + 20;

    self.showWoundCB = PengorosPlugins.UI.CheckBox();
    self.showWoundCB:SetParent(self);
    self.showWoundCB:SetText("Show Wound Effects");
    self.showWoundCB:SetPosition(0, y);
    self.showWoundCB:SetSize(380, 20);
    y = y + 20;

    self.showCorruptionCB = PengorosPlugins.UI.CheckBox();
    self.showCorruptionCB:SetParent(self);
    self.showCorruptionCB:SetText("Show Corruption Effects");
    self.showCorruptionCB:SetPosition(0, y);
    self.showCorruptionCB:SetSize(380, 20);
    y = y + 20;

    self.showCryCB = PengorosPlugins.UI.CheckBox();
    self.showCryCB:SetParent(self);
    self.showCryCB:SetText("Show Cry Effects");
    self.showCryCB:SetPosition(0, y);
    self.showCryCB:SetSize(380, 20);
    y = y + 20;

    self.showElementalCB = PengorosPlugins.UI.CheckBox();
    self.showElementalCB:SetParent(self);
    self.showElementalCB:SetText("Show Elemental Effects");
    self.showElementalCB:SetPosition(0, y);
    self.showElementalCB:SetSize(380, 20);
    y = y + 20;

    self.showPhysicalCB = PengorosPlugins.UI.CheckBox();
    self.showPhysicalCB:SetParent(self);
    self.showPhysicalCB:SetText("Show Physical Effects");
    self.showPhysicalCB:SetPosition(0, y);
    self.showPhysicalCB:SetSize(380, 20);
    y = y + 20;

    self.showSongCB = PengorosPlugins.UI.CheckBox();
    self.showSongCB:SetParent(self);
    self.showSongCB:SetText("Show Song Effects");
    self.showSongCB:SetPosition(0, y);
    self.showSongCB:SetSize(380, 20);
    y = y + 20;

    self.showUndefinedCB = PengorosPlugins.UI.CheckBox();
    self.showUndefinedCB:SetParent(self);
    self.showUndefinedCB:SetText("Show Undefined Effects");
    self.showUndefinedCB:SetPosition(0, y);
    self.showUndefinedCB:SetSize(380, 20);
    y = y + 30;

    self.minDurationCB = PengorosPlugins.UI.CheckBox();
    self.minDurationCB:SetParent(self);
    self.minDurationCB:SetText("Filter Effects Less Than Minimum Duration");
    self.minDurationCB:SetPosition(0, y);
    self.minDurationCB:SetSize(380, 20);
    self.minDurationCB.SetEnabled = function(sender, enabled)
        PengorosPlugins.UI.CheckBox.SetEnabled(sender, enabled);
        self.minDurationSlider:SetEnabled(enabled and sender:IsChecked());
    end
    self.minDurationCB.CheckedChanged = function(sender, args)
        self.minDurationSlider:SetEnabled(sender:IsChecked());
    end
    y = y + 25;

    self.minDurationSlider = PengorosPlugins.UI.Slider();
    self.minDurationSlider:SetParent(self);
    self.minDurationSlider:SetText("Minimum Duration (seconds)");
    self.minDurationSlider:SetPosition(29, y);
    self.minDurationSlider:SetSize(350, 40);
    self.minDurationSlider:SetStep(1);
    self.minDurationSlider:SetMin(1);
    self.minDurationSlider:SetMax(900);
    y = y + 50;

    self.maxDurationCB = PengorosPlugins.UI.CheckBox();
    self.maxDurationCB:SetParent(self);
    self.maxDurationCB:SetText("Filter Effects Greater Than Maximum Duration");
    self.maxDurationCB:SetPosition(0, y);
    self.maxDurationCB:SetSize(380, 20);
    self.maxDurationCB.SetEnabled = function(sender, enabled)
        PengorosPlugins.UI.CheckBox.SetEnabled(sender, enabled);
        self.maxDurationSlider:SetEnabled(enabled and sender:IsChecked());
    end
    self.maxDurationCB.CheckedChanged = function(sender, args)
        self.maxDurationSlider:SetEnabled(sender:IsChecked());
    end
    y = y + 25;

    self.maxDurationSlider = PengorosPlugins.UI.Slider();
    self.maxDurationSlider:SetParent(self);
    self.maxDurationSlider:SetText("Maximum Duration (seconds)");
    self.maxDurationSlider:SetPosition(29, y);
    self.maxDurationSlider:SetSize(350, 40);
    self.maxDurationSlider:SetStep(1);
    self.maxDurationSlider:SetMin(1);
    self.maxDurationSlider:SetMax(900);
    y = y + 50;

    self.ignoreWindow = IgnoreWindow();
    self.ignoreButton  = Turbine.UI.Lotro.Button();
    self.ignoreButton:SetParent(self);
    self.ignoreButton:SetPosition(56, y);
    self.ignoreButton:SetSize(160, 22);
    self.ignoreButton:SetText("Ignored Effects");
    self.ignoreButton.Click = function(sender, args)
        self.ignoreWindow:SetVisible(true);
    end

    self.overrideWindow = OverrideWindow();
    self.overrideButton  = Turbine.UI.Lotro.Button();
    self.overrideButton:SetParent(self);
    self.overrideButton:SetPosition(223, y);
    self.overrideButton:SetSize(160, 22);
    self.overrideButton:SetText("Always Shown Effects");
    self.overrideButton.Click = function(sender, args)
        self.overrideWindow:SetVisible(true);
    end
    y = y + 30;

    self.cdFilterTitle = PengorosPlugins.UI.PanelDivider();
    self.cdFilterTitle:SetParent(self);
    self.cdFilterTitle:SetText("Cool Down Filters");
    self.cdFilterTitle:SetSize(300, 30);
    self.cdFilterTitle:SetPosition(20, y);
    y = y + 35;
    
    self.showDiseaseCoolDownCB = PengorosPlugins.UI.CheckBox();
    self.showDiseaseCoolDownCB:SetParent(self);
    self.showDiseaseCoolDownCB:SetText("Show Disease");
    self.showDiseaseCoolDownCB:SetPosition(0, y);
    self.showDiseaseCoolDownCB:SetSize(380, 20);
    y = y + 20;

    self.showFearCoolDownCB = PengorosPlugins.UI.CheckBox();
    self.showFearCoolDownCB:SetParent(self);
    self.showFearCoolDownCB:SetText("Show Fear");
    self.showFearCoolDownCB:SetPosition(0, y);
    self.showFearCoolDownCB:SetSize(380, 20);
    y = y + 20;

    self.showPoisonCoolDownCB = PengorosPlugins.UI.CheckBox();
    self.showPoisonCoolDownCB:SetParent(self);
    self.showPoisonCoolDownCB:SetText("Show Poison");
    self.showPoisonCoolDownCB:SetPosition(0, y);
    self.showPoisonCoolDownCB:SetSize(380, 20);
    y = y + 20;

    self.showWoundCoolDownCB = PengorosPlugins.UI.CheckBox();
    self.showWoundCoolDownCB:SetParent(self);
    self.showWoundCoolDownCB:SetText("Show Wound");
    self.showWoundCoolDownCB:SetPosition(0, y);
    self.showWoundCoolDownCB:SetSize(380, 20);
    y = y + 20;

    self.showMoraleCoolDownCB = PengorosPlugins.UI.CheckBox();
    self.showMoraleCoolDownCB:SetParent(self);
    self.showMoraleCoolDownCB:SetText("Show Morale");
    self.showMoraleCoolDownCB:SetPosition(0, y);
    self.showMoraleCoolDownCB:SetSize(380, 20);
    y = y + 20;

    self.showPowerCoolDownCB = PengorosPlugins.UI.CheckBox();
    self.showPowerCoolDownCB:SetParent(self);
    self.showPowerCoolDownCB:SetText("Show Power");
    self.showPowerCoolDownCB:SetPosition(0, y);
    self.showPowerCoolDownCB:SetSize(380, 20);
    y = y + 30;

    self.flashingTitle = PengorosPlugins.UI.PanelDivider();
    self.flashingTitle:SetParent(self);
    self.flashingTitle:SetText("Flashing");
    self.flashingTitle:SetSize(300, 30);
    self.flashingTitle:SetPosition(20, y);
    y = y + 35;

    self.allowFlashingCB = PengorosPlugins.UI.CheckBox();
    self.allowFlashingCB:SetParent(self);
    self.allowFlashingCB:SetText("Flash Expiring Effects");
    self.allowFlashingCB:SetPosition(0, y);
    self.allowFlashingCB:SetSize(380, 20);
    y = y + 30;

    self.flashSlider = PengorosPlugins.UI.Slider();
    self.flashSlider:SetParent(self);
    self.flashSlider:SetText("Flash Time");
    self.flashSlider:SetPosition(29, y);
    self.flashSlider:SetSize(350, 40);
    self.flashSlider:SetStep(1);
    self.flashSlider:SetMin(1);
    self.flashSlider:SetMax(30);
    y = y + 50;

    self.uiTitle = PengorosPlugins.UI.PanelDivider();
    self.uiTitle:SetParent(self);
    self.uiTitle:SetText("UI Elements");
    self.uiTitle:SetSize(300, 30);
    self.uiTitle:SetPosition(20, y);
    y = y + 35;

    self.showEffectIconCB = PengorosPlugins.UI.CheckBox();
    self.showEffectIconCB:SetParent(self);
    self.showEffectIconCB:SetText("Show Effect Icon");
    self.showEffectIconCB:SetPosition(0, y);
    self.showEffectIconCB:SetSize(380, 20);
    y = y + 20;

    self.showEffectNameCB = PengorosPlugins.UI.CheckBox();
    self.showEffectNameCB:SetParent(self);
    self.showEffectNameCB:SetText("Show Effect Name");
    self.showEffectNameCB:SetPosition(0, y);
    self.showEffectNameCB:SetSize(380, 20);
    y = y + 20;

    self.showEffectTimerCB = PengorosPlugins.UI.CheckBox();
    self.showEffectTimerCB:SetParent(self);
    self.showEffectTimerCB:SetText("Show Effect Timer");
    self.showEffectTimerCB:SetPosition(0, y);
    self.showEffectTimerCB:SetSize(380, 20);
    y = y + 20;

    self.showDurationTimerCB = PengorosPlugins.UI.CheckBox();
    self.showDurationTimerCB:SetParent(self);
    self.showDurationTimerCB:SetText("Show Timer On Effects With No Duration");
    self.showDurationTimerCB:SetPosition(0, y);
    self.showDurationTimerCB:SetSize(380, 20);
    y = y + 25;

    self.fontLabel = PengorosPlugins.UI.Label();
    self.fontLabel:SetParent(self);
    self.fontLabel:SetSize(190, 20);
    self.fontLabel:SetPosition(0, y);
    self.fontLabel:SetText("Font");
    
    self.fontCombo = PengorosPlugins.UI.FontComboBox();
    self.fontCombo:SetParent(self);
    self.fontCombo:SetSize(190, 20);
    self.fontCombo:SetPosition(190, y);
    self.fontCombo:AddItem("23px tall", Turbine.UI.Lotro.Font.Verdana23, 27);
    self.fontCombo:AddItem("22px tall", Turbine.UI.Lotro.Font.Verdana22, 26);
    self.fontCombo:AddItem("20px tall", Turbine.UI.Lotro.Font.Verdana20, 24);
    self.fontCombo:AddItem("18px tall", Turbine.UI.Lotro.Font.Verdana18, 22);
    self.fontCombo:AddItem("16px tall", Turbine.UI.Lotro.Font.Verdana16, 20);
    self.fontCombo:AddItem("14px tall", Turbine.UI.Lotro.Font.Verdana14, 18);
    self.fontCombo:AddItem("12px tall", Turbine.UI.Lotro.Font.Verdana12, 16);
    self.fontCombo:AddItem("10px tall", Turbine.UI.Lotro.Font.Verdana10, 14);
    y = y + 30;

    self.widthSlider = PengorosPlugins.UI.Slider();
    self.widthSlider:SetParent(self);
    self.widthSlider:SetText("Width");
    self.widthSlider:SetPosition(29, y);
    self.widthSlider:SetSize(350, 40);
    self.widthSlider:SetStep(1);
    self.widthSlider:SetMin(50);
    self.widthSlider:SetMax(500);
    y = y + 50;

    self.heightSlider = PengorosPlugins.UI.Slider();
    self.heightSlider:SetParent(self);
    self.heightSlider:SetText("Height");
    self.heightSlider:SetPosition(29, y);
    self.heightSlider:SetSize(350, 40);
    self.heightSlider:SetStep(1);
    self.heightSlider:SetMin(10);
    self.heightSlider:SetMax(50);
    y = y + 50;

    self.colourTitle = PengorosPlugins.UI.PanelDivider();
    self.colourTitle:SetParent(self);
    self.colourTitle:SetText("Colour");
    self.colourTitle:SetSize(300, 30);
    self.colourTitle:SetPosition(20, y);
    y = y + 35;

    self.background = Turbine.UI.Control();
    self.background:SetParent(self);
    self.background:SetPosition(40, y);
    self.background:SetSize(90, 20);
    self.background:SetZOrder(10);
    self.background:SetBackColor(Turbine.UI.Color(.5,0,0,0));

    self.color = Turbine.UI.Control();
    self.color:SetParent(self);
    self.color:SetPosition(40, y);
    self.color:SetSize(90, 20);
    self.color:SetZOrder(20);
    self.color:SetBackColor(Turbine.UI.Color(1,.8,.8,0));

    self.colorCombo = PengorosPlugins.UI.ComboBox();
    self.colorCombo:SetParent(self);
    self.colorCombo:SetSize(220, 20);
    self.colorCombo:SetPosition(160, y);
    self.colorCombo:AddItem("Flash Elapsed", OptionsEffectPanel.FlashElapsed);
    self.colorCombo:AddItem("Flash Remaining", OptionsEffectPanel.FlashRemaining);
    self.colorCombo:AddItem("Disease Elapsed", OptionsEffectPanel.DiseaseElapsed);
    self.colorCombo:AddItem("Disease Remaining", OptionsEffectPanel.DiseaseRemaining);
    self.colorCombo:AddItem("Fear Elapsed", OptionsEffectPanel.FearElapsed);
    self.colorCombo:AddItem("Fear Remaining", OptionsEffectPanel.FearRemaining);
    self.colorCombo:AddItem("Poison Elapsed", OptionsEffectPanel.PoisonElapsed);
    self.colorCombo:AddItem("Poison Remaining", OptionsEffectPanel.PoisonRemaining);
    self.colorCombo:AddItem("Wound Elapsed", OptionsEffectPanel.WoundElapsed);
    self.colorCombo:AddItem("Wound Remaining", OptionsEffectPanel.WoundRemaining);
    self.colorCombo:AddItem("Corruption Elapsed", OptionsEffectPanel.CorruptionElapsed);
    self.colorCombo:AddItem("Corruption Remaining", OptionsEffectPanel.CorruptionRemaining);
    self.colorCombo:AddItem("Cry Elapsed", OptionsEffectPanel.CryElapsed);
    self.colorCombo:AddItem("Cry Remaining", OptionsEffectPanel.CryRemaining);
    self.colorCombo:AddItem("Elemental Elapsed", OptionsEffectPanel.ElementalElapsed);
    self.colorCombo:AddItem("Elemental Remaining", OptionsEffectPanel.ElementalRemaining);
    self.colorCombo:AddItem("Physical Elapsed", OptionsEffectPanel.PhysicalElapsed);
    self.colorCombo:AddItem("Physical Remaining", OptionsEffectPanel.PhysicalRemaining);
    self.colorCombo:AddItem("Song Elapsed", OptionsEffectPanel.SongElapsed);
    self.colorCombo:AddItem("Song Remaining", OptionsEffectPanel.SongRemaining);
    self.colorCombo:AddItem("Undefined Elapsed", OptionsEffectPanel.UndefinedElapsed);
    self.colorCombo:AddItem("Undefined Remaining", OptionsEffectPanel.UndefinedRemaining);
    self.colorCombo:AddItem("Morale CD Elapsed", OptionsEffectPanel.MoraleCoolDownElapsed);
    self.colorCombo:AddItem("Morale CD Remaining", OptionsEffectPanel.MoraleCoolDownRemaining);
    self.colorCombo:AddItem("Power CD Elapsed", OptionsEffectPanel.PowerCoolDownElapsed);
    self.colorCombo:AddItem("Power CD Remaining", OptionsEffectPanel.PowerCoolDownRemaining);
    self.colorCombo:AddItem("Disease CD Elapsed", OptionsEffectPanel.DiseaseCoolDownElapsed);
    self.colorCombo:AddItem("Disease CD Remaining", OptionsEffectPanel.DiseaseCoolDownRemaining);
    self.colorCombo:AddItem("Fear CD Elapsed", OptionsEffectPanel.FearCoolDownElapsed);
    self.colorCombo:AddItem("Fear CD Remaining", OptionsEffectPanel.FearCoolDownRemaining);
    self.colorCombo:AddItem("Poison CD Elapsed", OptionsEffectPanel.PoisonCoolDownElapsed);
    self.colorCombo:AddItem("Poison CD Remaining", OptionsEffectPanel.PoisonCoolDownRemaining);
    self.colorCombo:AddItem("Wound CD Elapsed", OptionsEffectPanel.WoundCoolDownElapsed);
    self.colorCombo:AddItem("Wound CD Remaining", OptionsEffectPanel.WoundCoolDownRemaining);
    self.colorCombo.SelectedIndexChanged = function(sender, args)
        self:ChangeColor(self.colors[args.selection]);
    end    
    y = y + 30;

    self.redSlider = PengorosPlugins.UI.Slider();
    self.redSlider:SetParent(self);
    self.redSlider:SetText("Red");
    self.redSlider:SetPosition(29, y);
    self.redSlider:SetSize(350, 40);
    self.redSlider:SetStep(1);
    self.redSlider:SetMin(0);
    self.redSlider:SetMax(255);
    self.redSlider.ValueChanged = function(sender, args)
        local color = self.colors[self.colorCombo:GetSelection()];
        color.r = args.value;
        self.color:SetBackColor(Turbine.UI.Color(color.a / 255, color.r / 255, color.g / 255, color.b / 255));
    end
    y = y + 50;

    self.greenSlider = PengorosPlugins.UI.Slider();
    self.greenSlider:SetParent(self);
    self.greenSlider:SetText("Green");
    self.greenSlider:SetPosition(29, y);
    self.greenSlider:SetSize(350, 40);
    self.greenSlider:SetStep(1);
    self.greenSlider:SetMin(0);
    self.greenSlider:SetMax(255);
    self.greenSlider.ValueChanged = function(sender, args)
        local color = self.colors[self.colorCombo:GetSelection()];
        color.g = args.value;
        self.color:SetBackColor(Turbine.UI.Color(color.a / 255, color.r / 255, color.g / 255, color.b / 255));
    end
    y = y + 50;

    self.blueSlider = PengorosPlugins.UI.Slider();
    self.blueSlider:SetParent(self);
    self.blueSlider:SetText("Blue");
    self.blueSlider:SetPosition(29, y);
    self.blueSlider:SetSize(350, 40);
    self.blueSlider:SetStep(1);
    self.blueSlider:SetMin(0);
    self.blueSlider:SetMax(255);
    self.blueSlider.ValueChanged = function(sender, args)
        local color = self.colors[self.colorCombo:GetSelection()];
        color.b = args.value;
        self.color:SetBackColor(Turbine.UI.Color(color.a / 255, color.r / 255, color.g / 255, color.b / 255));
    end
    y = y + 50;

    self.alphaSlider = PengorosPlugins.UI.Slider();
    self.alphaSlider:SetParent(self);
    self.alphaSlider:SetText("Alpha");
    self.alphaSlider:SetPosition(29, y);
    self.alphaSlider:SetSize(350, 40);
    self.alphaSlider:SetStep(1);
    self.alphaSlider:SetMin(0);
    self.alphaSlider:SetMax(255);
    self.alphaSlider.ValueChanged = function(sender, args)
        local color = self.colors[self.colorCombo:GetSelection()];
        color.a = args.value;
        self.color:SetBackColor(Turbine.UI.Color(color.a / 255, color.r / 255, color.g / 255, color.b / 255));
    end
    y = y + 50;

    -- set the container size
    self:SetSize(380, y);    
end

function OptionsEffectPanel:AddNewWindow()
    local window = EffectSettings();
    window.name = "New Window";
    self.windowCombo:AddItem(window.name, window);
    self.windowCombo:SetSelection(window);
    self:EnableControls(true);
end

function OptionsEffectPanel:CopyCurrentWindow()
    self:SaveWindowOptions(self.current); -- make sure the options are up to date 
    local window = self.current:Copy();
    window.name = window.name .. " - Copy";
    self.windowCombo:AddItem(window.name, window);
    self.windowCombo:SetSelection(window);
    self:EnableControls(true);
end

function OptionsEffectPanel:RemoveCurrentWindow()
    self.windowCombo:RemoveItem(self.current);
    self:EnableControls(self.windowCombo:GetItemCount() > 0);
end

function OptionsEffectPanel:ChangeColor(color)
    self.color:SetBackColor(Turbine.UI.Color(color["a"] / 255, color["r"] / 255, color["g"] / 255, color["b"] / 255));
    self.redSlider:SetValue(color["r"]);
    self.greenSlider:SetValue(color["g"]);
    self.blueSlider:SetValue(color["b"]);
    self.alphaSlider:SetValue(color["a"]);
end

function OptionsEffectPanel:Closed()
    self.ignoreWindow:Close();
    self.overrideWindow:Close();
    keyManager:RemoveListener(self);
end

function OptionsEffectPanel:UiHidden(hidden)
    if (hidden) then
        self.ignoreWasVisible = self.ignoreWindow:IsVisible();
        self.ignoreWindow:SetVisible(false);
        self.overrideWasVisible = self.overrideWindow:IsVisible();
        self.overrideWindow:SetVisible(false);
    else
        self.ignoreWindow:SetVisible(self.ignoreWasVisible);
        self.overrideWindow:SetVisible(self.overrideWasVisible);
    end
end

function OptionsEffectPanel:EnableControls(enable)
    self.windowCombo:SetEnabled(enable);
    self.removeButton:SetEnabled(enable);
    self.copyButton:SetEnabled(enable);
    self.nameLabel:SetEnabled(enable);
    self.nameText:SetEnabled(enable);
    self.showWindowCB:SetEnabled(enable);
    self.showDebuffBarCB:SetEnabled(enable);
    self.showBuffBarCB:SetEnabled(enable);
    self.showCoolDownBarCB:SetEnabled(enable);
    self.visibleTypeLabel:SetEnabled(enable);
    self.visibleTypeCombo:SetEnabled(enable);
    self.sortLabel:SetEnabled(enable);
    self.sortCombo:SetEnabled(enable);
    self.directionLabel:SetEnabled(enable);
    self.directionCombo:SetEnabled(enable);
    self.orderLabel:SetEnabled(enable);
    self.orderCombo:SetEnabled(enable);
    self.fillLabel:SetEnabled(enable);
    self.fillCombo:SetEnabled(enable);
    self.showCurableOnlyCB:SetEnabled(enable);
    self.showDiseaseCB:SetEnabled(enable);
    self.showFearCB:SetEnabled(enable);
    self.showPoisonCB:SetEnabled(enable);
    self.showWoundCB:SetEnabled(enable);
    self.showCorruptionCB:SetEnabled(enable);
    self.showCryCB:SetEnabled(enable);
    self.showElementalCB:SetEnabled(enable);
    self.showPhysicalCB:SetEnabled(enable);
    self.showSongCB:SetEnabled(enable);
    self.showUndefinedCB:SetEnabled(enable);
    self.minDurationCB:SetEnabled(enable);
    self.maxDurationCB:SetEnabled(enable);
    self.showDiseaseCoolDownCB:SetEnabled(enable);
    self.showFearCoolDownCB:SetEnabled(enable);
    self.showPoisonCoolDownCB:SetEnabled(enable);
    self.showWoundCoolDownCB:SetEnabled(enable);
    self.showMoraleCoolDownCB:SetEnabled(enable);
    self.showPowerCoolDownCB:SetEnabled(enable);
    self.ignoreButton:SetEnabled(enable);
    self.overrideButton:SetEnabled(enable);
    self.allowFlashingCB:SetEnabled(enable);
    self.flashSlider:SetEnabled(enable);
    self.showEffectIconCB:SetEnabled(enable);
    self.showEffectNameCB:SetEnabled(enable);
    self.showEffectTimerCB:SetEnabled(enable);
    self.showDurationTimerCB:SetEnabled(enable);
    self.fontLabel:SetEnabled(enable);
    self.fontCombo:SetEnabled(enable);
    self.widthSlider:SetEnabled(enable);
    self.heightSlider:SetEnabled(enable);
    self.colorCombo:SetEnabled(enable);
    self.redSlider:SetEnabled(enable);
    self.greenSlider:SetEnabled(enable);
    self.blueSlider:SetEnabled(enable);
    self.alphaSlider:SetEnabled(enable);
    self.color:SetVisible(enable);
    self.background:SetVisible(enable);
end

function OptionsEffectPanel:SetOptions()
    -- windows
    local i;
    local size = table.getn(pluginSettings.windows);
    for i = 1, size do
        local window = pluginSettings.windows[i]:Copy();
        self.windowCombo:AddItem(window.name, window);
    end
    
    if (size > 0) then
        self.windowCombo:SetSelection(self.windowCombo:GetItem(1));
    else
        self:EnableControls(false);
    end
end

function OptionsEffectPanel:SaveOptions()
    -- save the current window settings
    if (self.current ~= nil) then
        self:SaveWindowOptions(self.current);
    end
    
    -- collect all the windows into an array
    local windows = {};
    local i;
    for i = 1, self.windowCombo:GetItemCount() do
        windows[i] = self.windowCombo:GetItem(i);
    end
    
    -- overwrite the existing windows
    pluginSettings.windows = windows;
end

function OptionsEffectPanel:SetWindowOptions(settings)
    -- ignore 
    self.ignoreWindow:SetOptions(settings);
    self.overrideWindow:SetOptions(settings);
    
    -- general
    self.nameText:SetText(settings.name);
    self.showWindowCB:SetChecked(settings.enabled);
    self.showDebuffBarCB:SetChecked(settings.showDebuffBar);
    self.showBuffBarCB:SetChecked(settings.showBuffBar);
    self.showCoolDownBarCB:SetChecked(settings.showCoolDownBar);
    self.visibleTypeCombo:SetSelection(settings.visibleType);

    -- sorting
    self.sortCombo:SetSelection(settings.sortMethod);
    self.directionCombo:SetSelection(settings.sortAscending);
    self.orderCombo:SetSelection(settings.barOrder);
    self.fillCombo:SetSelection(settings.fillBottomToTop);

    -- effect filters
    self.showCurableOnlyCB:SetChecked(settings.showCurableOnly);
    self.showDiseaseCB:SetChecked(settings.showDisease);
    self.showFearCB:SetChecked(settings.showFear);
    self.showWoundCB:SetChecked(settings.showWound);
    self.showPoisonCB:SetChecked(settings.showPoison);
    self.showCorruptionCB:SetChecked(settings.showCorruption);
    self.showCryCB:SetChecked(settings.showCry);
    self.showElementalCB:SetChecked(settings.showElemental);
    self.showPhysicalCB:SetChecked(settings.showPhysical);
    self.showSongCB:SetChecked(settings.showSong);
    self.showUndefinedCB:SetChecked(settings.showUndefined);
    self.minDurationCB:SetChecked(settings.minDurationFilter);
    self.minDurationSlider:SetValue(settings.minDuration);
    self.maxDurationCB:SetChecked(settings.maxDurationFilter);
    self.maxDurationSlider:SetValue(settings.maxDuration);
    
    -- cool down filters
    self.showDiseaseCoolDownCB:SetChecked(settings.showDiseaseCD);
    self.showFearCoolDownCB:SetChecked(settings.showFearCD);
    self.showPoisonCoolDownCB:SetChecked(settings.showPoisonCD);
    self.showWoundCoolDownCB:SetChecked(settings.showWoundCD);
    self.showMoraleCoolDownCB:SetChecked(settings.showMoraleCD);
    self.showPowerCoolDownCB:SetChecked(settings.showPowerCD);
    
    -- flahing
    self.allowFlashingCB:SetChecked(settings.allowFlashing);
    self.flashSlider:SetValue(settings.flashTime);
    
    -- ui elements
    self.showEffectIconCB:SetChecked(settings.showEffectIcon);
    self.showEffectNameCB:SetChecked(settings.showEffectName);
    self.showEffectTimerCB:SetChecked(settings.showEffectTimer);
    self.showDurationTimerCB:SetChecked(settings.showEffectDuration);
    self.fontCombo:SetSelection(settings.font);
    self.widthSlider:SetValue(settings.barWidth);
    self.heightSlider:SetValue(settings.barHeight);
    
    -- colors
    self.colors = {};
    self.colors[OptionsEffectPanel.FlashElapsed] = settings:GetElapsedColorArray(Settings.Flash);
    self.colors[OptionsEffectPanel.FlashRemaining] = settings:GetRemainingColorArray(Settings.Flash);
    self.colors[OptionsEffectPanel.DiseaseElapsed] = settings:GetElapsedColorArray(Settings.DiseaseEffect);
    self.colors[OptionsEffectPanel.DiseaseRemaining] = settings:GetRemainingColorArray(Settings.DiseaseEffect);
    self.colors[OptionsEffectPanel.FearElapsed] = settings:GetElapsedColorArray(Settings.FearEffect);
    self.colors[OptionsEffectPanel.FearRemaining] = settings:GetRemainingColorArray(Settings.FearEffect);
    self.colors[OptionsEffectPanel.PoisonElapsed] = settings:GetElapsedColorArray(Settings.PoisonEffect);
    self.colors[OptionsEffectPanel.PoisonRemaining] = settings:GetRemainingColorArray(Settings.PoisonEffect);
    self.colors[OptionsEffectPanel.WoundElapsed] = settings:GetElapsedColorArray(Settings.WoundEffect);
    self.colors[OptionsEffectPanel.WoundRemaining] = settings:GetRemainingColorArray(Settings.WoundEffect);
    self.colors[OptionsEffectPanel.CorruptionElapsed] = settings:GetElapsedColorArray(Settings.CorruptionEffect);
    self.colors[OptionsEffectPanel.CorruptionRemaining] = settings:GetRemainingColorArray(Settings.CorruptionEffect);
    self.colors[OptionsEffectPanel.CryElapsed] = settings:GetElapsedColorArray(Settings.CryEffect);
    self.colors[OptionsEffectPanel.CryRemaining] = settings:GetRemainingColorArray(Settings.CryEffect);
    self.colors[OptionsEffectPanel.ElementalElapsed] = settings:GetElapsedColorArray(Settings.ElementalEffect);
    self.colors[OptionsEffectPanel.ElementalRemaining] = settings:GetRemainingColorArray(Settings.ElementalEffect);
    self.colors[OptionsEffectPanel.PhysicalElapsed] = settings:GetElapsedColorArray(Settings.PhysicalEffect);
    self.colors[OptionsEffectPanel.PhysicalRemaining] = settings:GetRemainingColorArray(Settings.PhysicalEffect);
    self.colors[OptionsEffectPanel.SongElapsed] = settings:GetElapsedColorArray(Settings.SongEffect);
    self.colors[OptionsEffectPanel.SongRemaining] = settings:GetRemainingColorArray(Settings.SongEffect);
    self.colors[OptionsEffectPanel.UndefinedElapsed] = settings:GetElapsedColorArray(Settings.UndefinedEffect);
    self.colors[OptionsEffectPanel.UndefinedRemaining] = settings:GetRemainingColorArray(Settings.UndefinedEffect);
    self.colors[OptionsEffectPanel.MoraleCoolDownElapsed] = settings:GetElapsedColorArray(Settings.MoraleCoolDown);
    self.colors[OptionsEffectPanel.MoraleCoolDownRemaining] = settings:GetRemainingColorArray(Settings.MoraleCoolDown);
    self.colors[OptionsEffectPanel.PowerCoolDownElapsed] = settings:GetElapsedColorArray(Settings.PowerCoolDown);
    self.colors[OptionsEffectPanel.PowerCoolDownRemaining] = settings:GetRemainingColorArray(Settings.PowerCoolDown);
    self.colors[OptionsEffectPanel.DiseaseCoolDownElapsed] = settings:GetElapsedColorArray(Settings.DiseaseCoolDown);
    self.colors[OptionsEffectPanel.DiseaseCoolDownRemaining] = settings:GetRemainingColorArray(Settings.DiseaseCoolDown);
    self.colors[OptionsEffectPanel.FearCoolDownElapsed] = settings:GetElapsedColorArray(Settings.FearCoolDown);
    self.colors[OptionsEffectPanel.FearCoolDownRemaining] = settings:GetRemainingColorArray(Settings.FearCoolDown);
    self.colors[OptionsEffectPanel.PoisonCoolDownElapsed] = settings:GetElapsedColorArray(Settings.PoisonCoolDown);
    self.colors[OptionsEffectPanel.PoisonCoolDownRemaining] = settings:GetRemainingColorArray(Settings.PoisonCoolDown);
    self.colors[OptionsEffectPanel.WoundCoolDownElapsed] = settings:GetElapsedColorArray(Settings.WoundCoolDown);
    self.colors[OptionsEffectPanel.WoundCoolDownRemaining] = settings:GetRemainingColorArray(Settings.WoundCoolDown);    
    self.background:SetBackColor(settings:GetBackColor());
    self.colorCombo:SetSelection(OptionsEffectPanel.FlashElapsed);
    self:ChangeColor(self.colors[OptionsEffectPanel.FlashElapsed]);
end

function OptionsEffectPanel:SaveWindowOptions(settings)
    -- ignore
    self.ignoreWindow:SaveOptions(settings);
    self.overrideWindow:SaveOptions(settings);

    -- general
    settings.name = self.nameText:GetText();
    settings.enabled = self.showWindowCB:IsChecked();
    settings.showDebuffBar = self.showDebuffBarCB:IsChecked();
    settings.showBuffBar = self.showBuffBarCB:IsChecked();
    settings.showCoolDownBar = self.showCoolDownBarCB:IsChecked();
    settings.visibleType = self.visibleTypeCombo:GetSelection();
   
    -- sorting
    settings.sortMethod = self.sortCombo:GetSelection();
    settings.sortAscending = self.directionCombo:GetSelection();
    settings.barOrder = self.orderCombo:GetSelection();
    settings.fillBottomToTop = self.fillCombo:GetSelection();
       
    -- effect filters
    settings.showCurableOnly = self.showCurableOnlyCB:IsChecked();
    settings.showDisease = self.showDiseaseCB:IsChecked();
    settings.showFear = self.showFearCB:IsChecked();
    settings.showWound = self.showWoundCB:IsChecked();
    settings.showPoison = self.showPoisonCB:IsChecked();
    settings.showCorruption = self.showCorruptionCB:IsChecked();
    settings.showCry = self.showCryCB:IsChecked();
    settings.showElemental = self.showElementalCB:IsChecked();
    settings.showPhysical = self.showPhysicalCB:IsChecked();
    settings.showSong = self.showSongCB:IsChecked();
    settings.showUndefined = self.showUndefinedCB:IsChecked();
    settings.minDurationFilter = self.minDurationCB:IsChecked();
    settings.minDuration = self.minDurationSlider:GetValue();
    settings.maxDurationFilter = self.maxDurationCB:IsChecked();
    settings.maxDuration = self.maxDurationSlider:GetValue();
    
    -- cool down filters
    settings.showDiseaseCD = self.showDiseaseCoolDownCB:IsChecked();
    settings.showFearCD = self.showFearCoolDownCB:IsChecked();
    settings.showPoisonCD = self.showPoisonCoolDownCB:IsChecked();
    settings.showWoundCD = self.showWoundCoolDownCB:IsChecked();
    settings.showMoraleCD = self.showMoraleCoolDownCB:IsChecked();
    settings.showPowerCD = self.showPowerCoolDownCB:IsChecked();
       
    -- flashing
    settings.allowFlashing = self.allowFlashingCB:IsChecked();
    settings.flashTime = self.flashSlider:GetValue();
   
    -- ui elements
    settings.showEffectIcon = self.showEffectIconCB:IsChecked();
    settings.showEffectName = self.showEffectNameCB:IsChecked();
    settings.showEffectTimer = self.showEffectTimerCB:IsChecked();
    settings.showEffectDuration = self.showDurationTimerCB:IsChecked();
    settings.font = self.fontCombo:GetSelection();
    settings.barWidth = self.widthSlider:GetValue();
    settings.barHeight = self.heightSlider:GetValue();
   
    -- colors
    settings:SetElapsedColorArray(Settings.Flash, self.colors[OptionsEffectPanel.FlashElapsed]);
    settings:SetRemainingColorArray(Settings.Flash, self.colors[OptionsEffectPanel.FlashRemaining]);
    settings:SetElapsedColorArray(Settings.DiseaseEffect, self.colors[OptionsEffectPanel.DiseaseElapsed]);
    settings:SetRemainingColorArray(Settings.DiseaseEffect, self.colors[OptionsEffectPanel.DiseaseRemaining]);
    settings:SetElapsedColorArray(Settings.FearEffect, self.colors[OptionsEffectPanel.FearElapsed]);
    settings:SetRemainingColorArray(Settings.FearEffect, self.colors[OptionsEffectPanel.FearRemaining]);
    settings:SetElapsedColorArray(Settings.PoisonEffect, self.colors[OptionsEffectPanel.PoisonElapsed]);
    settings:SetRemainingColorArray(Settings.PoisonEffect, self.colors[OptionsEffectPanel.PoisonRemaining]);
    settings:SetElapsedColorArray(Settings.WoundEffect, self.colors[OptionsEffectPanel.WoundElapsed]);
    settings:SetRemainingColorArray(Settings.WoundEffect, self.colors[OptionsEffectPanel.WoundRemaining]);
    settings:SetElapsedColorArray(Settings.CorruptionEffect, self.colors[OptionsEffectPanel.CorruptionElapsed]);
    settings:SetRemainingColorArray(Settings.CorruptionEffect, self.colors[OptionsEffectPanel.CorruptionRemaining]);
    settings:SetElapsedColorArray(Settings.CryEffect, self.colors[OptionsEffectPanel.CryElapsed]);
    settings:SetRemainingColorArray(Settings.CryEffect, self.colors[OptionsEffectPanel.CryRemaining]);
    settings:SetElapsedColorArray(Settings.ElementalEffect, self.colors[OptionsEffectPanel.ElementalElapsed]);
    settings:SetRemainingColorArray(Settings.ElementalEffect, self.colors[OptionsEffectPanel.ElementalRemaining]);
    settings:SetElapsedColorArray(Settings.PhysicalEffect, self.colors[OptionsEffectPanel.PhysicalElapsed]);
    settings:SetRemainingColorArray(Settings.PhysicalEffect, self.colors[OptionsEffectPanel.PhysicalRemaining]);
    settings:SetElapsedColorArray(Settings.SongEffect, self.colors[OptionsEffectPanel.SongElapsed]);
    settings:SetRemainingColorArray(Settings.SongEffect, self.colors[OptionsEffectPanel.SongRemaining]);
    settings:SetElapsedColorArray(Settings.UndefinedEffect, self.colors[OptionsEffectPanel.UndefinedElapsed]);
    settings:SetRemainingColorArray(Settings.UndefinedEffect, self.colors[OptionsEffectPanel.UndefinedRemaining]);
    settings:SetElapsedColorArray(Settings.MoraleCoolDown, self.colors[OptionsEffectPanel.MoraleCoolDownElapsed]);
    settings:SetRemainingColorArray(Settings.MoraleCoolDown, self.colors[OptionsEffectPanel.MoraleCoolDownRemaining]);
    settings:SetElapsedColorArray(Settings.PowerCoolDown, self.colors[OptionsEffectPanel.PowerCoolDownElapsed]);
    settings:SetRemainingColorArray(Settings.PowerCoolDown, self.colors[OptionsEffectPanel.PowerCoolDownRemaining]);
    settings:SetElapsedColorArray(Settings.DiseaseCoolDown, self.colors[OptionsEffectPanel.DiseaseCoolDownElapsed]);
    settings:SetRemainingColorArray(Settings.DiseaseCoolDown, self.colors[OptionsEffectPanel.DiseaseCoolDownRemaining]);
    settings:SetElapsedColorArray(Settings.FearCoolDown, self.colors[OptionsEffectPanel.FearCoolDownElapsed]);
    settings:SetRemainingColorArray(Settings.FearCoolDown, self.colors[OptionsEffectPanel.FearCoolDownRemaining]);
    settings:SetElapsedColorArray(Settings.PoisonCoolDown, self.colors[OptionsEffectPanel.PoisonCoolDownElapsed]);
    settings:SetRemainingColorArray(Settings.PoisonCoolDown, self.colors[OptionsEffectPanel.PoisonCoolDownRemaining]);
    settings:SetElapsedColorArray(Settings.WoundCoolDown, self.colors[OptionsEffectPanel.WoundCoolDownElapsed]);
    settings:SetRemainingColorArray(Settings.WoundCoolDown, self.colors[OptionsEffectPanel.WoundCoolDownRemaining]);
end
