import "Turbine.UI";

OptionsLogPanel = class(Turbine.UI.Control);

function OptionsLogPanel:Constructor()
    Turbine.UI.Control.Constructor(self);

    local y = 0;
    self.generalTitle = PengorosPlugins.UI.PanelDivider();
    self.generalTitle:SetParent(self);
    self.generalTitle:SetText("General");
    self.generalTitle:SetSize(300, 30);
    self.generalTitle:SetPosition(20, y);
    y = y + 35;

    self.enabledCB = PengorosPlugins.UI.CheckBox();
    self.enabledCB:SetParent(self);
    self.enabledCB:SetText("Logging Enabled");
    self.enabledCB:SetPosition(0, y);
    self.enabledCB:SetSize(380, 20);
    self.enabledCB.CheckedChanged = function(sender, args)
        self:EnableControls(sender:IsChecked());
    end
    y = y + 20;

    self.logIdCB = PengorosPlugins.UI.CheckBox();
    self.logIdCB:SetParent(self);
    self.logIdCB:SetText("Log Id");
    self.logIdCB:SetPosition(0, y);
    self.logIdCB:SetSize(380, 20);
    y = y + 20;

    self.logNameCB = PengorosPlugins.UI.CheckBox();
    self.logNameCB:SetParent(self);
    self.logNameCB:SetText("Log Name");
    self.logNameCB:SetPosition(0, y);
    self.logNameCB:SetSize(380, 20);
    y = y + 20;

    self.logDescriptionCB = PengorosPlugins.UI.CheckBox();
    self.logDescriptionCB:SetParent(self);
    self.logDescriptionCB:SetText("Log Description");
    self.logDescriptionCB:SetPosition(0, y);
    self.logDescriptionCB:SetSize(380, 20);
    y = y + 20;

    self.logCategoryCB = PengorosPlugins.UI.CheckBox();
    self.logCategoryCB:SetParent(self);
    self.logCategoryCB:SetText("Log Category");
    self.logCategoryCB:SetPosition(0, y);
    self.logCategoryCB:SetSize(380, 20);
    y = y + 20;

    self.logDurationCB = PengorosPlugins.UI.CheckBox();
    self.logDurationCB:SetParent(self);
    self.logDurationCB:SetText("Log Duration");
    self.logDurationCB:SetPosition(0, y);
    self.logDurationCB:SetSize(380, 20);
    y = y + 20;

    self.logCurableCB = PengorosPlugins.UI.CheckBox();
    self.logCurableCB:SetParent(self);
    self.logCurableCB:SetText("Log Is Curable");
    self.logCurableCB:SetPosition(0, y);
    self.logCurableCB:SetSize(380, 20);
    y = y + 25;

    self.logDebuffCB = PengorosPlugins.UI.CheckBox();
    self.logDebuffCB:SetParent(self);
    self.logDebuffCB:SetText("Log Is Debuff");
    self.logDebuffCB:SetPosition(0, y);
    self.logDebuffCB:SetSize(380, 20);
    y = y + 25;

    self.filterTitle = PengorosPlugins.UI.PanelDivider();
    self.filterTitle:SetParent(self);
    self.filterTitle:SetText("Filters");
    self.filterTitle:SetSize(300, 30);
    self.filterTitle:SetPosition(20, y);
    y = y + 35;

    self.showBuffsCB = PengorosPlugins.UI.CheckBox();
    self.showBuffsCB:SetParent(self);
    self.showBuffsCB:SetText("Show Buffs");
    self.showBuffsCB:SetPosition(0, y);
    self.showBuffsCB:SetSize(380, 20);
    y = y + 20;

    self.showDebuffsCB = PengorosPlugins.UI.CheckBox();
    self.showDebuffsCB:SetParent(self);
    self.showDebuffsCB:SetText("Show Debuffs");
    self.showDebuffsCB:SetPosition(0, y);
    self.showDebuffsCB:SetSize(380, 20);
    y = y + 20;

    -- set the container size
    self:SetSize(380, y);
end

function OptionsLogPanel:EnableControls(enable)
    self.logIdCB:SetEnabled(enable);
    self.logNameCB:SetEnabled(enable);
    self.logDescriptionCB:SetEnabled(enable);
    self.logCategoryCB:SetEnabled(enable);
    self.logDurationCB:SetEnabled(enable);
    self.logCurableCB:SetEnabled(enable);
    self.logDebuffCB:SetEnabled(enable);
    self.showBuffsCB:SetEnabled(enable);
    self.showDebuffsCB:SetEnabled(enable);
end

function OptionsLogPanel:SetOptions()
    local settings = pluginSettings.log;
    self.enabledCB:SetChecked(settings.enabled);
    self.logIdCB:SetChecked(settings.logId);
    self.logNameCB:SetChecked(settings.logName);
    self.logDescriptionCB:SetChecked(settings.logDescription);
    self.logCategoryCB:SetChecked(settings.logCategory);
    self.logDurationCB:SetChecked(settings.logDuration);
    self.logCurableCB:SetChecked(settings.logCurable);
    self.logDebuffCB:SetChecked(settings.logDebuff);
    self.showBuffsCB:SetChecked(settings.showBuffs);
    self.showDebuffsCB:SetChecked(settings.showDebuffs);
end

function OptionsLogPanel:SaveOptions()
    local settings = pluginSettings.log;
    settings.enabled = self.enabledCB:IsChecked();
    settings.logId = self.logIdCB:IsChecked();
    settings.logName = self.logNameCB:IsChecked();
    settings.logDescription = self.logDescriptionCB:IsChecked();
    settings.logCategory = self.logCategoryCB:IsChecked();
    settings.logDuration = self.logDurationCB:IsChecked();
    settings.logCurable = self.logCurableCB:IsChecked();
    settings.logDebuff = self.logDebuffCB:IsChecked();
    settings.showBuffs = self.showBuffsCB:IsChecked();
    settings.showDebuffs = self.showDebuffsCB:IsChecked();
end
