import "Turbine.UI";

OptionsQuickslotPanel = class(Turbine.UI.Control);

function OptionsQuickslotPanel:Constructor()
    Turbine.UI.Control.Constructor(self);

    local y = 0;
    self.barTitle = PengorosPlugins.UI.PanelDivider();
    self.barTitle:SetParent(self);
    self.barTitle:SetText("Quickslot Bars");
    self.barTitle:SetSize(300, 30);
    self.barTitle:SetPosition(20, y);
    y = y + 35;
    
    self.barLabel = PengorosPlugins.UI.Label();
    self.barLabel:SetParent(self);
    self.barLabel:SetSize(176, 20);
    self.barLabel:SetPosition(0, y);
    self.barLabel:SetText("Bar");
    
    self.barCombo = PengorosPlugins.UI.ComboBox();
    self.barCombo:SetParent(self);
    self.barCombo:SetSize(204, 20);
    self.barCombo:SetPosition(176, y);
    self.barCombo.SelectedIndexChanged = function(sender, args)
        if (self.current ~= nil) then
            self:SaveBarOptions(self.current);
        end
        self:SetBarOptions(args.selection);
        self.current = args.selection;
    end
    y = y + 30;
    
    self.newButton  = Turbine.UI.Lotro.Button();
    self.newButton:SetParent(self);
    self.newButton:SetPosition(69, y);
    self.newButton:SetSize(100, 22);
    self.newButton:SetText("New");
    self.newButton.Click = function(sender, args)
        self:AddNewBar();
    end

    self.copyButton  = Turbine.UI.Lotro.Button();
    self.copyButton:SetParent(self);
    self.copyButton:SetPosition(176, y);
    self.copyButton:SetSize(100, 22);
    self.copyButton:SetText("Copy");
    self.copyButton.Click = function(sender, args)
        self:CopyCurrentBar();
    end

    self.removeButton  = Turbine.UI.Lotro.Button();
    self.removeButton:SetParent(self);
    self.removeButton:SetPosition(283, y);
    self.removeButton:SetSize(100, 22);
    self.removeButton:SetText("Remove");
    self.removeButton.Click = function(sender, args)
        self:RemoveCurrentBar();
    end
    y = y + 30;

    self.generalTitle = PengorosPlugins.UI.PanelDivider();
    self.generalTitle:SetParent(self);
    self.generalTitle:SetText("General");
    self.generalTitle:SetSize(300, 30);
    self.generalTitle:SetPosition(20, y);
    y = y + 35;

    self.nameLabel = PengorosPlugins.UI.Label();
    self.nameLabel:SetParent(self);
    self.nameLabel:SetSize(100, 20);
    self.nameLabel:SetPosition(0, y);
    self.nameLabel:SetText("Name");
    
    self.nameText = Turbine.UI.Lotro.TextBox();
    self.nameText:SetParent(self);
    self.nameText:SetSize(280, 20);
    self.nameText:SetPosition(100, y);
    self.nameText:SetFont(Turbine.UI.Lotro.Font.Verdana14);
    self.nameText:SetMultiline(false);
    self.nameText:SetWantsUpdates(true);
    self.nameText.Update = function(sender, args)
        self.barCombo:UpdateSelectionText(self.nameText:GetText());
    end
    y = y + 30;

    self.showQuickslotCB = PengorosPlugins.UI.CheckBox();
    self.showQuickslotCB:SetParent(self);
    self.showQuickslotCB:SetText("Enabled");
    self.showQuickslotCB:SetPosition(0, y);
    self.showQuickslotCB:SetSize(380, 20);
    y = y + 25;

    self.visibleTypeLabel = PengorosPlugins.UI.Label();
    self.visibleTypeLabel:SetParent(self);
    self.visibleTypeLabel:SetSize(190, 20);
    self.visibleTypeLabel:SetPosition(0, y);
    self.visibleTypeLabel:SetText("Show Bar");
    
    self.visibleTypeCombo = PengorosPlugins.UI.ComboBox();
    self.visibleTypeCombo:SetParent(self);
    self.visibleTypeCombo:SetSize(190, 20);
    self.visibleTypeCombo:SetPosition(190, y);
    self.visibleTypeCombo:AddItem("Always", EffectWindow.VisibleAlways);
    self.visibleTypeCombo:AddItem("Only In Combat", EffectWindow.VisibleInCombat);
    self.visibleTypeCombo:AddItem("Only Out Of Combat", EffectWindow.VisibleOutOfCombat);
    y = y + 30;

    self.filterTitle = PengorosPlugins.UI.PanelDivider();
    self.filterTitle:SetParent(self);
    self.filterTitle:SetText("Filters");
    self.filterTitle:SetSize(300, 30);
    self.filterTitle:SetPosition(20, y);
    y = y + 35;

    self.showDiseaseCB = PengorosPlugins.UI.CheckBox();
    self.showDiseaseCB:SetParent(self);
    self.showDiseaseCB:SetText("Show Disease Slot");
    self.showDiseaseCB:SetPosition(0, y);
    self.showDiseaseCB:SetSize(380, 20);
    y = y + 20;

    self.showFearCB = PengorosPlugins.UI.CheckBox();
    self.showFearCB:SetParent(self);
    self.showFearCB:SetText("Show Fear Slot");
    self.showFearCB:SetPosition(0, y);
    self.showFearCB:SetSize(380, 20);
    y = y + 20;

    self.showPoisonCB = PengorosPlugins.UI.CheckBox();
    self.showPoisonCB:SetParent(self);
    self.showPoisonCB:SetText("Show Poison Slot");
    self.showPoisonCB:SetPosition(0, y);
    self.showPoisonCB:SetSize(380, 20);
    y = y + 20;

    self.showWoundCB = PengorosPlugins.UI.CheckBox();
    self.showWoundCB:SetParent(self);
    self.showWoundCB:SetText("Show Wound Slot");
    self.showWoundCB:SetPosition(0, y);
    self.showWoundCB:SetSize(380, 20);
    y = y + 20;

    self.showMoraleCB = PengorosPlugins.UI.CheckBox();
    self.showMoraleCB:SetParent(self);
    self.showMoraleCB:SetText("Show Morale Slot");
    self.showMoraleCB:SetPosition(0, y);
    self.showMoraleCB:SetSize(380, 20);
    y = y + 20;

    self.showPowerCB = PengorosPlugins.UI.CheckBox();
    self.showPowerCB:SetParent(self);
    self.showPowerCB:SetText("Show Power Slot");
    self.showPowerCB:SetPosition(0, y);
    self.showPowerCB:SetSize(380, 20);
    y = y + 30;

    self.moraleSlider = PengorosPlugins.UI.Slider();
    self.moraleSlider:SetParent(self);
    self.moraleSlider:SetText("Morale Percent");
    self.moraleSlider:SetPosition(29, y);
    self.moraleSlider:SetSize(350, 40);
    self.moraleSlider:SetStep(1);
    self.moraleSlider:SetMin(1);
    self.moraleSlider:SetMax(99);
    y = y + 50;

    self.powerSlider = PengorosPlugins.UI.Slider();
    self.powerSlider:SetParent(self);
    self.powerSlider:SetText("Power Percent");
    self.powerSlider:SetPosition(29, y);
    self.powerSlider:SetSize(350, 40);
    self.powerSlider:SetStep(1);
    self.powerSlider:SetMin(1);
    self.powerSlider:SetMax(99);
    y = y + 50;

    self.quickslotTitle = PengorosPlugins.UI.PanelDivider();
    self.quickslotTitle:SetParent(self);
    self.quickslotTitle:SetText("Quick Slots");
    self.quickslotTitle:SetSize(300, 30);
    self.quickslotTitle:SetPosition(20, y);
    y = y + 35;

    self.moraleQuickslot = Turbine.UI.Lotro.Quickslot();
    self.moraleQuickslot:SetParent(self);
    self.moraleQuickslot:SetSize(36, 36);
    self.moraleQuickslot:SetPosition(79, y);
    
    self.powerQuickslot = Turbine.UI.Lotro.Quickslot();
    self.powerQuickslot:SetParent(self);
    self.powerQuickslot:SetSize(36, 36);
    self.powerQuickslot:SetPosition(172, y);

    self.diseaseQuickslot = Turbine.UI.Lotro.Quickslot();
    self.diseaseQuickslot:SetParent(self);
    self.diseaseQuickslot:SetSize(36, 36);
    self.diseaseQuickslot:SetPosition(265, y);
    y = y + 40;
    
    self.moraleLabel = PengorosPlugins.UI.Label();
    self.moraleLabel:SetParent(self);
    self.moraleLabel:SetSize(92, 20);
    self.moraleLabel:SetPosition(51, y);
    self.moraleLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
    self.moraleLabel:SetText("Morale");
    
    self.powerLabel = PengorosPlugins.UI.Label();
    self.powerLabel:SetParent(self);
    self.powerLabel:SetSize(92, 20);
    self.powerLabel:SetPosition(144, y);
    self.powerLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
    self.powerLabel:SetText("Power");

    self.diseaseLabel = PengorosPlugins.UI.Label();
    self.diseaseLabel:SetParent(self);
    self.diseaseLabel:SetSize(92, 20);
    self.diseaseLabel:SetPosition(237, y);
    self.diseaseLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
    self.diseaseLabel:SetText("Disease");
    y = y + 20;

    self.fearQuickslot = Turbine.UI.Lotro.Quickslot();
    self.fearQuickslot:SetParent(self);
    self.fearQuickslot:SetSize(36, 36);
    self.fearQuickslot:SetPosition(79, y);
    
    self.poisonQuickslot = Turbine.UI.Lotro.Quickslot();
    self.poisonQuickslot:SetParent(self);
    self.poisonQuickslot:SetSize(36, 36);
    self.poisonQuickslot:SetPosition(172, y);

    self.woundQuickslot = Turbine.UI.Lotro.Quickslot();
    self.woundQuickslot:SetParent(self);
    self.woundQuickslot:SetSize(36, 36);
    self.woundQuickslot:SetPosition(265, y);
    y = y + 40;
    
    self.fearLabel = PengorosPlugins.UI.Label();
    self.fearLabel:SetParent(self);
    self.fearLabel:SetSize(92, 20);
    self.fearLabel:SetPosition(51, y);
    self.fearLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
    self.fearLabel:SetText("Fear");
    
    self.poisonLabel = PengorosPlugins.UI.Label();
    self.poisonLabel:SetParent(self);
    self.poisonLabel:SetSize(92, 20);
    self.poisonLabel:SetPosition(144, y);
    self.poisonLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
    self.poisonLabel:SetText("Poison");

    self.woundLabel = PengorosPlugins.UI.Label();
    self.woundLabel:SetParent(self);
    self.woundLabel:SetSize(92, 20);
    self.woundLabel:SetPosition(237, y);
    self.woundLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
    self.woundLabel:SetText("Wound");
    y = y + 25;

    -- set the container size
    self:SetSize(380, y);
end

function OptionsQuickslotPanel:AddNewBar()
    local bar = QuickslotSettings();
    bar.name = "New Quickslot";
    self.barCombo:AddItem(bar.name, bar);
    self.barCombo:SetSelection(bar);
    self:EnableControls(true);
end

function OptionsQuickslotPanel:CopyCurrentBar()
    self:SaveBarOptions(self.current); -- make sure the options are up to date 
    local bar = self.current:Copy();
    bar.name = bar.name .. " - Copy";
    self.barCombo:AddItem(bar.name, bar);
    self.barCombo:SetSelection(bar);
    self:EnableControls(true);
end

function OptionsQuickslotPanel:RemoveCurrentBar()
    self.barCombo:RemoveItem(self.current);
    self:EnableControls(self.barCombo:GetItemCount() > 0);
end

function OptionsQuickslotPanel:EnableControls(enable)
    self.barCombo:SetEnabled(enable);
    self.copyButton:SetEnabled(enable);
    self.removeButton:SetEnabled(enable);
    self.nameLabel:SetEnabled(enable);
    self.nameText:SetEnabled(enable);
    self.showQuickslotCB:SetEnabled(enable);
    self.visibleTypeLabel:SetEnabled(enable);
    self.visibleTypeCombo:SetEnabled(enable);
    self.showDiseaseCB:SetEnabled(enable);
    self.showFearCB:SetEnabled(enable);
    self.showPoisonCB:SetEnabled(enable);
    self.showWoundCB:SetEnabled(enable);
    self.showMoraleCB:SetEnabled(enable);
    self.showPowerCB:SetEnabled(enable);
    self.moraleSlider:SetEnabled(enable);
    self.powerSlider:SetEnabled(enable);
    self.moraleLabel:SetEnabled(enable);
    self.powerLabel:SetEnabled(enable);
    self.diseaseLabel:SetEnabled(enable);
    self.fearLabel:SetEnabled(enable);
    self.poisonLabel:SetEnabled(enable);
    self.woundLabel:SetEnabled(enable);
    self.moraleQuickslot:SetVisible(enable);
    self.powerQuickslot:SetVisible(enable);
    self.diseaseQuickslot:SetVisible(enable);
    self.fearQuickslot:SetVisible(enable);
    self.poisonQuickslot:SetVisible(enable);
    self.woundQuickslot:SetVisible(enable);
end

function OptionsQuickslotPanel:SetOptions()
    -- bars
    local i;
    local size = table.getn(pluginSettings.quickslots);
    for i = 1, size do
        local bar = pluginSettings.quickslots[i]:Copy();
        self.barCombo:AddItem(bar.name, bar);
    end
    
    if (size > 0) then
        self.barCombo:SetSelection(self.barCombo:GetItem(1));
    else
        self:EnableControls(false);
    end
end

function OptionsQuickslotPanel:SaveOptions()
    -- save the current bar settings
    if (self.current ~= nil) then
        self:SaveBarOptions(self.current);
    end
    
    -- collect all the bars into an array
    local bars = {};
    local i;
    for i = 1, self.barCombo:GetItemCount() do
        bars[i] = self.barCombo:GetItem(i);
    end
    
    -- overwrite the existing quickslots
    pluginSettings.quickslots = bars;
end

function OptionsQuickslotPanel:SetBarOptions(settings)
    -- quickslots
    self.nameText:SetText(settings.name);
    self.showQuickslotCB:SetChecked(settings.enabled);
    self.visibleTypeCombo:SetSelection(settings.visibleType);
    
    self.showDiseaseCB:SetChecked(settings.showDisease);
    self.showFearCB:SetChecked(settings.showFear);
    self.showWoundCB:SetChecked(settings.showWound);
    self.showPoisonCB:SetChecked(settings.showPoison);
    self.showMoraleCB:SetChecked(settings.showMorale);
    self.showPowerCB:SetChecked(settings.showPower);
    self.moraleSlider:SetValue(settings.moralePercent * 100);
    self.powerSlider:SetValue(settings.powerPercent * 100);

    -- use pcall to catch any errors thrown by setting an invalid shortcut
    if (not pcall(function() self.moraleQuickslot:SetShortcut(Turbine.UI.Lotro.Shortcut(settings.moraleType, settings.moraleData)); end)) then
        self.moraleQuickslot:SetShortcut(nil);
    end
    if (not pcall(function() self.powerQuickslot:SetShortcut(Turbine.UI.Lotro.Shortcut(settings.powerType, settings.powerData)); end)) then
        self.powerQuickslot:SetShortcut(nil);
    end
    if (not pcall(function() self.diseaseQuickslot:SetShortcut(Turbine.UI.Lotro.Shortcut(settings.diseaseType, settings.diseaseData)); end)) then
        self.diseaseQuickslot:SetShortcut(nil);
    end
    if (not pcall(function() self.fearQuickslot:SetShortcut(Turbine.UI.Lotro.Shortcut(settings.fearType, settings.fearData)); end)) then
        self.fearQuickslot:SetShortcut(nil);
    end
    if (not pcall(function() self.poisonQuickslot:SetShortcut(Turbine.UI.Lotro.Shortcut(settings.poisonType, settings.poisonData)); end)) then
        self.poisonQuickslot:SetShortcut(nil);
    end
    if (not pcall(function() self.woundQuickslot:SetShortcut(Turbine.UI.Lotro.Shortcut(settings.woundType, settings.woundData)); end)) then
        self.woundQuickslot:SetShortcut(nil);
    end
end

function OptionsQuickslotPanel:SaveBarOptions(settings)
    -- quickslots
    settings.name = self.nameText:GetText();
    settings.enabled = self.showQuickslotCB:IsChecked();
    settings.visibleType = self.visibleTypeCombo:GetSelection();

    settings.showDisease = self.showDiseaseCB:IsChecked();
    settings.showFear = self.showFearCB:IsChecked();
    settings.showWound = self.showWoundCB:IsChecked();
    settings.showPoison = self.showPoisonCB:IsChecked();
    settings.showMorale = self.showMoraleCB:IsChecked();
    settings.showPower = self.showPowerCB:IsChecked();
    settings.moralePercent = self.moraleSlider:GetValue() / 100;
    settings.powerPercent = self.powerSlider:GetValue() / 100;
    
    local shortcut = self.moraleQuickslot:GetShortcut();
    if (shortcut:GetData() ~= "") then
        settings.moraleType = shortcut:GetType();
        settings.moraleData = shortcut:GetData();
    end
    shortcut = self.powerQuickslot:GetShortcut();
    if (shortcut:GetData() ~= "") then
        settings.powerType = shortcut:GetType();
        settings.powerData = shortcut:GetData();
    end
    shortcut = self.diseaseQuickslot:GetShortcut();
    if (shortcut:GetData() ~= "") then
        settings.diseaseType = shortcut:GetType();
        settings.diseaseData = shortcut:GetData();
    end
    shortcut = self.fearQuickslot:GetShortcut();
    if (shortcut:GetData() ~= "") then
        settings.fearType = shortcut:GetType();
        settings.fearData = shortcut:GetData();
    end
    shortcut = self.poisonQuickslot:GetShortcut();
    if (shortcut:GetData() ~= "") then
        settings.poisonType = shortcut:GetType();
        settings.poisonData = shortcut:GetData();
    end
    shortcut = self.woundQuickslot:GetShortcut();
    if (shortcut:GetData() ~= "") then
        settings.woundType = shortcut:GetType();
        settings.woundData = shortcut:GetData();
    end
end

function OptionsQuickslotPanel:Destroy()
    -- cleanup the quickslots so the client doesn't crash
    self.moraleQuickslot:SetShortcut(nil);
    self.powerQuickslot:SetShortcut(nil);
    self.diseaseQuickslot:SetShortcut(nil);
    self.fearQuickslot:SetShortcut(nil);
    self.poisonQuickslot:SetShortcut(nil);
    self.woundQuickslot:SetShortcut(nil);
end
